<?php
/**
 * S5ClanRoster model for S5ClanRoster Component
 * 
 * @package     
 * @subpackage Components
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

/**
 * S5ClanRoster Model
 *
 * @package   
 * @subpackage Components
 */
class S5ClanRosterModelS5ClanRoster extends JModel
{
	/**
	 * data array
	 *
	 * @var array
	 */
	var $_data;

	/**
	 * Retrieves the category data
	 * @return array Array of objects containing the data from the database
	 */
	function getitems(){ 
	
		global $mainframe, $option;
		$db 			=& JFactory::getDBO(); 
		$config 		= new JConfig();
		$task 			= JArrayHelper::getValue( $_REQUEST, 'task', '' ); 
		$context		= $option."categories";	
		
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order', 'filter_order', 'ordering', 'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );	
		$limit 			= intval( $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int' ) );
		$limitstart 	= intval( $mainframe->getUserStateFromRequest( "limitstart", 'limitstart', 0, 'int' ) );
		
		// build query 's order
		$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir;
		
		// Get the total records
		$query = 'SELECT *' 
				.' FROM #__s5clanroster_categories'
				."\n {$orderby}";
		$db->setQuery($query);
		$items = $db->loadObjectList();
		//generate error msg		
		if ($db->getErrorNum()) {
			echo $db->stderr();
			exit;
		}

		// establish the hierarchy of the menu
		$children = array();
		// first pass - collect children
		foreach ($items as $v )
		{
			$pt = $v->parent;
			$list = @$children[$pt] ? $children[$pt] : array();
			array_push( $list, $v );
			$children[$pt] = $list;
		}
		// second pass - get an indent list of the items
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 4 );		

		// Ensure ampersands and double quotes are encoded in item titles
		foreach ($list as $i => $item) {
			$treename = $item->treename;
			$treename = JFilterOutput::ampReplace($treename);
			$treename = str_replace('"', '&quot;', $treename);
			$list[$i]->treename = $treename;
		}

		$total = count($list);
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		// slice out elements based on limits
		$list = array_slice( $list, $pageNav->limitstart, $pageNav->limit );
		
		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		$return = array("items"=>$list,"pageNav"=>$pageNav,"lists"=>$lists);
		
		return $return;
	}
	
	/**
	 * Display the param for this category
	 *
	 * @return html list
	 */	
	function getcategory_user_param() {
		global $mainframe, $option;
			
		$db	=& JFactory::getDBO();			
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		
		// array where[]
		$where = array();
		$where[] = " id  = '".$cid[0]."'";
		
		// build query 's where
		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );			
		
		// get list of param
		$sql = "SELECT user_param "
		."\n FROM `#__s5clanroster_categories` "
		."\n ".$where;
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		
		if($rows[0]->user_param != ''){
			$user_param = explode("\n",$rows[0]->user_param);
			$return = array();
			foreach($user_param as $user_param_row => $user_param_value){
				$return_values = explode("=",$user_param_value);
				$return[$return_values[0]] = $return_values[1];
			}
		}else{
			$return = array();
		}
		
		return $return; 	
	}	
	
	/**
	 * Display the param for this category
	 *
	 * @return html list
	 */	
	function getcategory_param($id = '') {
		global $mainframe, $option;
			
		$db	=& JFactory::getDBO();
		if($id == ''){			
			$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		}else{
			$cid[0] = $id;
		}

		if(isset($cid[0])){
			// array where[]
			$where = array();
			$where[] = " id  = '".$cid[0]."'";
			
			// build query 's where
			$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );			
			
			// get list of param
			$sql = "SELECT param "
			."\n FROM `#__s5clanroster_categories` "
			."\n ".$where;
			$db->setQuery($sql);
			$rows = $db->loadObjectList();
	
			if($rows[0]->param != ''){
				$user_param = explode("\n",$rows[0]->param);
				$return = array();
				foreach($user_param as $user_param_row => $user_param_value){
					$return_values = explode("=",$user_param_value);
					$each_field = explode(",",$return_values[1]);
					$return[$return_values[0]][] = $each_field[0];
					$return[$return_values[0]][] = $each_field[1];
					$return[$return_values[0]][] = $each_field[2];
				}
			}else{
				$return = array();
			}
		}else{
			$return = array();
		}
		return $return; 	
	}		
	
	/**
	 * save/edit new category
	 *
	 * @return unknown_type
	 */
	function save() {
		global $mainframe;

		$row 				=& $this->getTable();
		$cid 				= JRequest::getVar( 'id', array(), '', 'array' );
		$field_name			= JRequest::getVar( 'field_name', array(), '', 'array' );
		$field_type			= JRequest::getVar( 'field_type', array(), '', 'array' );
		$field_status		= JRequest::getVar( 'field_status', array(), '', 'array' );
		$parent 			= JRequest::getVar( 'parent', '');
		$username 			= JRequest::getVar( 'username', '1');
		$user_real_name		= JRequest::getVar( 'user_real_name', '1');
		$user_email			= JRequest::getVar( 'user_email', '1');
		$user_photo			= JRequest::getVar( 'user_photo', '1');	
		$photo_position		= JRequest::getVar( 'photo_position', '0');
		$records_per_rows 	= JRequest::getVar( 'records_per_rows', '3');
		$rows_per_page 		= JRequest::getVar( 'rows_per_page', '3');		
		$desc_length 		= JRequest::getVar( 'desc_length', '');
		JArrayHelper::toInteger($cid, array());

		// is new or not
		$is_new = true;
		if ($cid[0] != 0) {
			$is_new = false;
			$row->load((int) $cid[0]);
			//reorder the item if a new parent is assign
			if((int) $parent != $row->parent){
				$where = " parent = ".(int) $parent;
				$row->ordering = $row->getNextOrder( $where );
			}
		}else{
			// if new item order last in appropriate group
			$where = " parent = ".(int) $parent;
			$row->ordering = $row->getNextOrder( $where );		
		}

		if (!$row->bind( $_POST )) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}
		
		//generate user param
		$row->user_param 	= "username=".$username;
		$row->user_param 	.= "\n"."user_real_name=".$user_real_name;
		$row->user_param 	.= "\n"."user_email=".$user_email;
		$row->user_param 	.= "\n"."user_photo=".$user_photo;
		$row->user_param 	.= "\n"."photo_position=".$photo_position;
		$row->user_param 	.= "\n"."records_per_rows=".$records_per_rows;
		$row->user_param 	.= "\n"."rows_per_page=".$rows_per_page;
		$row->user_param 	.= "\n"."desc_length=".$desc_length;		

		//generate extra fields
		foreach($field_name as $field_name_row => $field_name_value){
			$fields_param[$field_name_row] = $field_name_row."=".$field_name_value.",".$field_type[$field_name_row].",".$field_status[$field_name_row];
		}
		$row->param = implode("\n",$fields_param);

		if (!$row->store()) {
			$msg = "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		}else{
			if($is_new === true){
				$msg = JText::_("CAT SUCC ADDED");
			}else{
				$msg = JText::_("CAT SUCC EDITED");
			}
		}

		return $msg;
	}	
	
	/**
	 * save a copy category
	 *
	 * @return unknown_type
	 */
	function savecopy() {
		global $mainframe;

		$row 				=& $this->getTable();
		$old_id				= JRequest::getVar( 'old_id', '' );
		$parent 			= JRequest::getVar( 'parent', '');
		
		$old_id_array = explode(",",$old_id);
		
		foreach($old_id_array as $old_id){
			$row->load($old_id);
			
			///see if new category have the same parent
			//if yes the new cat name will be "copy of..."
			if($row->parent == $parent){
				$row->name = "Copy of ".$row->name;
			}
			$row->parent = $parent;
			$row->id = '';
			$row->user_id = '';
			$where = " parent = ".(int) $row->parent;
			$row->ordering = $row->getNextOrder( $where );
	
			if (!$row->check()) {
				echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
				return false;
			}
	
			if (!$row->store()) {
				$msg = "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			}else{
				$msg = JText::_("CAT SUCC ADDED");
			}
		}
		
		return $msg;
	}		
	
	/**
	 * delete category
	 *
	 * @return unknown_type
	 */
	function delete() {
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		$db	=& JFactory::getDBO(); 				
		JArrayHelper::toInteger($cid, array());

		if (count($cid) > 0) {
			$row =& $this->getTable();
			foreach ($cid as $id) {
				//delete children also
				$query = 'SELECT id' .
						' FROM #__s5clanroster_categories' .
						' WHERE parent = '.(int) $id;
				$db->setQuery( $query );
				$rows_child = $db->loadObjectList();
				// Make sure there aren't any errors
				if ($db->getErrorNum()) {
					$this->setError($db->getErrorMsg());
					return false;
				}
				foreach ($rows_child as $row_child){
					$row->delete($row_child->id);
				}
				//delete original category (parent)
				$row->delete($id);
			}
			$msg = JText::_("CAT SUCC DELETED");
		} else {
			JError::raiseError(500, JText::_( 'SELECT CAT DELETE', true ));
		}
		return $msg;
	}	
	
	/**
	 * get a category for edit
	 * 
	 * (non-PHPdoc)
	 * @see libraries/joomla/application/component/JView#display($tpl)
	 */
	function getitem() {
		global $mainframe, $option;

		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		
		if(!empty($cid)){
			JArrayHelper::toInteger($cid, array());		
			
			// array where[]
			$where = array();
			$where[] = " id  = '".$cid[0]."'";
			
			// build query 's where
			$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );		
			
			// get list of category
			$sql = "SELECT * "
			."\n FROM `#__s5clanroster_categories` "
			."\n {$where}";
			$db->setQuery($sql);
			$rows = $db->loadObjectList();
			//generate error msg		
			if ($db->getErrorNum()) {
				echo $db->stderr();
				exit;
			}	
			return $rows[0];
		}else{
			return false;
		}
	}	
	
	/**
	 * get a category for edit
	 * 
	 * (non-PHPdoc)
	 * @see libraries/joomla/application/component/JView#display($tpl)
	 */
	function getcopy_item() {
		global $mainframe, $option;

		$db		=& JFactory::getDBO();
		$cid 	= JRequest::getVar( 'cid', array(), '', 'array' );
		$return = array();
		
		if(!empty($cid)){
			JArrayHelper::toInteger($cid, array());		
			
			foreach($cid as $id){
				// array where[]
				$where = array();
				$where[] = " id  = '".$id."'";
				
				// build query 's where
				$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );		
				
				// get list of category
				$sql = "SELECT * "
				."\n FROM `#__s5clanroster_categories` "
				."\n {$where}";
				$db->setQuery($sql);
				$rows = $db->loadObjectList();
				//generate error msg		
				if ($db->getErrorNum()) {
					echo $db->stderr();
					exit;
				}
				$return[] = $rows[0];
			}
			
			return $return;
		}else{
			return false;
		}
	}	
	
	/**
	 * publish or unpublish categories
	 *
	 * @param integer $state
	 * @return boolean
	 */
	function publish($state) {
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cid, array());

		if (count($cid) > 0) {
			$row =& $this->getTable();
			foreach ($cid as $id) {
				$row->load($id);
				$row->published = $state;
				$row->store();

				if (!$row->check()) {
					$this->setError($row->getError());
					return false;
				}
				if (!$row->store()) {
					$this->setError($row->getError());
					return false;
				}
			}
		}
		return true;
	}
	
	/**
	 * Method order up(-1)/down(1) a department with one record
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function order(){
		global $mainframe;
		$db 	=& JFactory::getDBO();

		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		//generate move up or dowm
		$task = JRequest::getCmd('task');
		if ($task == 'orderup') {
			$direction = -1;
		} elseif ($task == 'orderdown') {
			$direction = +1;
		}else{
			$direction = $ordering;
		}
		
		if (isset( $cid[0] ))
		{
			$row = & $this->getTable();
			$row->load( (int) $cid[0] );
			$row->move($direction,' parent = '.(int) $row->parent );

			$cache = & JFactory::getCache('com_s5clanroster');
			$cache->clean();
		}		

		$msg = JText::_('ORDERING SAVED');

		return $msg;
	}
	
	function saveOrder()
	{
		global $mainframe;

		// Initialize variables
		$db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = & $this->getTable();

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
			}
		}

		$cache = & JFactory::getCache('com_s5clanroster');
		$cache->clean();

		$msg = JText::_('ORDERING SAVED');
		return $msg;
	}
	

}
?>