<?php
/**
 * Users View for S5ClanRoster Component
 * 
 * @package
 * @subpackage Components
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * Settings View
 *
 * @package
 * @subpackage Components
 */
class S5ClanRosterViewS5Users extends JView
{
	/**
	 * Settings view display method
	 * @return void
	 **/
	function display($tpl = null)
	{
		JToolBarHelper::title( JText::_( 'TITLE USERS' ), 'generic.png' );
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		
		// Get settings
		$return	= & $this->get( 'users');
		$this->assignRef('rows', $return['items']);
		$this->assignRef('pageNav', $return['pageNav']);
		$this->assignRef('lists', $return['lists']);		
		
		parent::display($tpl);
	}
	
	/**
	 * add user
	 * 
	 * @param $tpl
	 * @return unknown_type
	 */
	function add($tpl = null) { 
		JToolBarHelper::title(   JText::_( 'TITLE NEW USER' ), 'generic.png' );
		JToolBarHelper::Save();
		JToolBarHelper::Apply();		
		JToolBarHelper::Cancel();
		
		$user = $this->get('user');
		$this->assignRef('user', $user['user']);
		$this->assignRef('lists', $user['lists']);		
		
		$me	= JFactory::getUser();
		$this->assignRef('me', $me);
		
		$document =& JFactory::getDocument();	
		$document->addScript('components/com_s5clanroster/helpers/helper.js');
		
		$this->setLayout('add');
		parent::display($tpl);
	}	
	
	/**
	 * edit user
	 *
	 */
	function edit($tpl = null) {
		JToolBarHelper::title(   JText::_( 'TITLE EDIT USER' ), 'generic.png' );
		JToolBarHelper::Save();
		JToolBarHelper::Apply();		
		JToolBarHelper::Cancel();
		
		$user = $this->get('user');
		$this->assignRef('user', $user['user']);
		$this->assignRef('lists', $user['lists']);		
		
		$me	= JFactory::getUser();
		$this->assignRef('me', $me);		

		$user_photo = $this->get( 'user_photo');
		$this->assignRef('user_photo', $user_photo);				

		$document =& JFactory::getDocument();	

		$document->addScript('components/com_s5clanroster/helpers/helper.js');		
		$layout_js = "window.onload = function() {";
		$layout_js .= "loopSelected(".$user['user']->id.");\n";
		$layout_js .= "};";
		$document->addScriptDeclaration($layout_js);

		$this->setLayout('add');
		parent::display($tpl);
	}		
}
?>